---
title: Object.getOwnPropertySymbols()
slug: Web/JavaScript/Reference/Global_Objects/Object/getOwnPropertySymbols
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Object
---
<div>{{JSRef}}</div>

<p>The <strong><code>Object.getOwnPropertySymbols()</code></strong> method returns an array of all symbol properties found directly upon a given object.</p>

<div>{{EmbedInteractiveExample("pages/js/object-getownpropertysymbols.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js notranslate">Object.getOwnPropertySymbols(<var>obj</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>obj</var></code></dt>
 <dd>The object whose symbol properties are to be returned.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An array of all symbol properties found directly upon the given object.</p>

<h2 id="Description">Description</h2>

<p>Similar to {{jsxref("Object.getOwnPropertyNames()")}}, you can get all symbol properties of a given object as an array of symbols. Note that {{jsxref("Object.getOwnPropertyNames()")}} itself does not contain the symbol properties of an object and only the string properties.</p>

<p>As all objects have no own symbol properties initially, <code>Object.getOwnPropertySymbols()</code> returns an empty array unless you have set symbol properties on your object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_getOwnPropertySymbols">Using getOwnPropertySymbols</h3>

<pre class="brush: js notranslate">var obj = {};
var a = Symbol('a');
var b = Symbol.for('b');

obj[a] = 'localSymbol';
obj[b] = 'globalSymbol';

var objectSymbols = Object.getOwnPropertySymbols(obj);

console.log(objectSymbols.length); // 2
console.log(objectSymbols);        // [Symbol(a), Symbol(b)]
console.log(objectSymbols[0]);     // Symbol(a)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.getownpropertysymbols', 'Object.getOwnPropertySymbols')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Object.getOwnPropertySymbols")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.getOwnPropertyNames()")}}</li>
 <li>{{jsxref("Symbol")}}</li>
</ul>
